# Bibliotheken laden


try:
    from machine import Pin, PWM
    from time import sleep_ms
except:
    from time import sleep
    
    class PWM:
        def __init__(self, pin):
            return
        def duty_u16(self, x):
            return
        def freq(self, x):
            return
    def Pin(x):
        return x
    def sleep_ms(x):
        sleep(float(x) / 1000)
        return


class Buzzer():

    C    = 261.63
    DES  = 277.18
    D    = 293.66
    ES   = 311.13
    E    = 329.63
    F    = 349.23
    GES  = 369.99
    G    = 392.00
    AS   = 415.30
    A    = 440.00
    B    = 466.16
    H    = 493.88

    __ms = 1000
    WHOLE   = __ms
    HALF    = __ms / 2
    QUARTER = __ms / 4
    EIGHTH  = __ms / 8

    def __init__(self, pin):
        # PWM und GPIO initialisieren
        self.pwm = PWM(Pin(pin))
        self.pwm.duty_u16(0)
        return
        
        
    
    def beep(self, freq, milliSecs, level=0.5):

        MAXLEVEL = 65536.0 / 2
        duty = int(MAXLEVEL * level * level)   # Nicht linear
            
        self.pwm.duty_u16(duty)
        self.pwm.freq(int(freq))
        
        # Tondauer in Millisekunden
        sleep_ms(int(milliSecs))
        
        # Kurze Pause in Anschluss
        self.pwm.duty_u16(0)
        sleep_ms(int(milliSecs/16))




if __name__ == "__main__":


    buzzer = Buzzer(16)
    
    buzzer.beep(Buzzer.C, Buzzer.QUARTER)
    buzzer.beep(Buzzer.D, Buzzer.QUARTER)
    buzzer.beep(Buzzer.E, Buzzer.QUARTER)
    buzzer.beep(Buzzer.F, Buzzer.QUARTER)
    buzzer.beep(Buzzer.G, Buzzer.HALF)
    buzzer.beep(Buzzer.G, Buzzer.HALF)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.G, Buzzer.WHOLE)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.A, Buzzer.QUARTER)
    buzzer.beep(Buzzer.G, Buzzer.WHOLE)
    buzzer.beep(Buzzer.F, Buzzer.QUARTER)
    buzzer.beep(Buzzer.F, Buzzer.QUARTER)
    buzzer.beep(Buzzer.F, Buzzer.QUARTER)
    buzzer.beep(Buzzer.F, Buzzer.QUARTER)
    buzzer.beep(Buzzer.E, Buzzer.HALF)
    buzzer.beep(Buzzer.E, Buzzer.HALF)
    buzzer.beep(Buzzer.G, Buzzer.QUARTER)
    buzzer.beep(Buzzer.G, Buzzer.QUARTER)
    buzzer.beep(Buzzer.G, Buzzer.QUARTER)
    buzzer.beep(Buzzer.G, Buzzer.QUARTER)
    buzzer.beep(Buzzer.C, Buzzer.WHOLE)
