# Bibliotheken laden
from time import time
from time import sleep


try:
    from machine import Pin
except:
    class Pin():
        IN = 0
        PULL_UP = 0
        PULL_DOWN = 1
        def __init__(self, pin, io, pull):
            self.pull = pull
            return
        def value(self):
            if (self.pull == Pin.PULL_UP):
                return int(msTicks() / 1000) % 20 < 5
            return int(msTicks() / 1000) % 20 >= 5
    # dummy class to enable testing under Windows










class DipSwitch:

    LOW = 0
    HIGH = 1
    
    def __init__(self, pins, onLevel):

        self.onLevel = onLevel

        self.switch = []
        for pin in pins:
            if (self.onLevel == 0):
                self.switch.append(Pin(pin, Pin.IN, Pin.PULL_UP))
            else:
                self.switch.append(Pin(pin, Pin.IN, Pin.PULL_DOWN))

        return


#    def __isPressed(self):
#        return (self.onLevel == self.btn.value())



    def size(self):
        return (len(self.switch))

    def __getitem__(self, index):
        return (self.switch[index].value() == self.onLevel)





if __name__ == "__main__":

    DIP_PINS = [ 19, 20, 21, 22 ]
    dipSwitch = DipSwitch(DIP_PINS, DipSwitch.LOW)

    for i in range(dipSwitch.size()):
        print (">>>>>>>> DIP-Switch: " + str(dipSwitch[i]))


