



def msTicks():
    try:
        from utime import ticks_ms
        return ticks_ms()
    except:
        from time import time
        return time() * 1000





class CyclicTimerMs():

    def __init__(self, size):
        self.set(size)
    
    
    def set(self, size):
        self.size = size
        self.start()


    def start(self):
        now = msTicks()
        self.startTicks = now


    def overrun(self, sync = False):
        now = msTicks()
        
        ticks = now - self.startTicks
        
        if sync:
            print ("ticks: " + str(ticks))
            overRun = ticks >= self.size / 2
            self.startTicks = now
            return overRun
                
        overRun = ticks >= self.size
        if overRun:
            self.startTicks += self.size
        
        return overRun        

