



class NeoPixel:
    def __init__(self, pin, n):

        self.strip_length = n

        color = (0, 0, 0)
        self.leds = [color for x in range(self.strip_length)]


    def fill(self, color):
        self.leds = [color for x in range(self.strip_length)]



    def write(self):
#        print("NeoPixel().write")
        self.__printRing()





    def __setitem__(self, index, color):
        self.leds[index] = color
#        print("NeoPixel[" + str(index) + "] = " + str(color))
        
    def __getitem__(self, index):
        return(self.leds[index])




    def __escapes(self):
    
        escapes = [("\033[38;2;" + str(self.leds[index][0]) + ";" + str(self.leds[index][1]) + ";" + str(self.leds[index][2]) + "m") for index in range(self.strip_length)]
        return escapes


    def __printLine(self):
    
        escapes = self.__escapes()

        s = ""
        for index in range(self.strip_length):
            s += escapes[index] + "#"
            
        s += "\033[39m\033[49m"
        print (s)

                                     
    def __printRing(self):
    
        escapes = self.__escapes()
        resetEscape = "\033[39m\033[49m"
        cursorUpEscape = "\033[11A"
        cursorOffEscape = "\033[?25l"


        s = "        " + escapes[23] + "#  " + escapes[0] + "#  " + escapes[1] + "#"
        s += resetEscape
        print (s)
        s = "     " + escapes[22] + "#           " + escapes[2] + "#"
        s += resetEscape
        print (s)
        s = "" + escapes[21] + "  #                 " + escapes[3] + "#"
        s += resetEscape
        print (s)
        s = "" + escapes[20] + " #                   " + escapes[4] + "#"
        s += resetEscape
        print (s)
        s = "" + escapes[19] + "#                     " + escapes[5] + "#"
        s += resetEscape
        print (s)
        s = "" + escapes[18] + "#                     " + escapes[6] + "#"
        s += resetEscape
        print (s)
        s = "" + escapes[17] + "#                     " + escapes[7] + "#"
        s += resetEscape
        print (s)
        s = " " + escapes[16] + "#                   " + escapes[8] + "#"
        s += resetEscape
        print (s)
        s = "   " + escapes[15] + "#               " + escapes[9] + "#"
        s += resetEscape
        print (s)
        s = "     " + escapes[14] + "#           " + escapes[10] + "#"
        s += resetEscape
        print (s)
        s = "        " + escapes[13] + "#  " + escapes[12] + "#  " + escapes[11] + "#"
        s += resetEscape + cursorUpEscape + cursorOffEscape
        print (s)




                 ## ## ##            
             ##            ##        
          ##                  ##
         ##                    ##
        ##                      ##
        ##                      ##
        ##                      ##
         ##                    ##
           ##                ##
             ##            ##
                 ## ## ##
                                   
           